#!/bin/sh

#--------SANE Backends start-stop-status script
#--------package maintained at pcloadletter.co.uk

PKG_FOLDER="/var/packages/sane-backends"
DLOG="${PKG_FOLDER}/target/var/sane-find-scanner.log"
COMMENT="# Synology SANE Backends Package"
source /etc/profile
source /root/.profile


EnvCheck ()
#updates to DSM will reset these changes so check them each startup
{
  #/etc/services should contain 1 line added by this package tagged with trailing comments
  COUNT=`grep -c "${COMMENT}$" /etc/services`
  if [ $COUNT != 1 ]; then

    #remove any existing mods
    sed -i "/${COMMENT}/d" /etc/services

    #make the required changes
    echo "sane-port       6566/tcp                        ${COMMENT}" >> /etc/services
  fi
  #/etc/inetd.conf should contain 1 line added by this package tagged with trailing comments
  COUNT=`grep -c "${COMMENT}$" /etc/inetd.conf`
  if [ $COUNT != 1 ]; then

    #remove any existing mods
    sed -i "/${COMMENT}/d" /etc/inetd.conf

    #make the required changes      
    echo "sane-port stream tcp    nowait  root    ${PKG_FOLDER}/target/sbin/saned    saned  ${COMMENT}" >> /etc/inetd.conf
  fi
  #/usr/syno/etc/synoservice.d/pkgctl-sane-backends.cfg should contain an upstart entry for inetd
  COUNT=`grep -c "inetd" /usr/syno/etc/synoservice.d/pkgctl-sane-backends.cfg`
  if [ $COUNT != 1 ]; then
    sed -i -r "s/(\"pkgctl-sane-backends\")/\1,\"inetd\"/" /usr/syno/etc/synoservice.d/pkgctl-sane-backends.cfg
  fi
}

case $1 in
  start)
    EnvCheck
    reload inetd
    echo `date "+%F %R"` startup. `${PKG_FOLDER}/target/bin/sane-find-scanner -q` > ${PKG_FOLDER}/target/var/sane-find-scanner.log
    echo `date "+%F %R"` `${PKG_FOLDER}/target/bin/scanimage -L` >> ${PKG_FOLDER}/target/var/sane-find-scanner.log
    exit 0
  ;;

  stop)
    #remove any existing config changes
    sed -i "/${COMMENT}/d" /etc/services
    sed -i "/${COMMENT}/d" /etc/inetd.conf
    killall -q saned
    reload inetd
    exit 0
  ;;

  status)
    grep -q "${COMMENT}" /etc/inetd.conf && exit 0 || exit 1
  ;;

  log)
    echo "${DLOG}"
    exit 0
  ;;

esac
